- NAME
- SYNOPSIS
- DESCRIPTION
- NOTES
- RETURN VALUES
- SEE ALSO
- COPYRIGHT

# NAME

SSL_set_session - set a TLS/SSL session to be used during TLS/SSL connect

# SYNOPSIS

     #include <openssl/ssl.h>

     int SSL_set_session(SSL *ssl, SSL_SESSION *session);

# DESCRIPTION

`SSL_set_session()` sets session to be used when the TLS/SSL connection is to be established. `SSL_set_session()` is only useful for TLS/SSL clients. When the session is set, the reference count of session is incremented by 1. If the session is not reused, the reference count is decremented again during `SSL_connect()`. Whether the session was reused can be queried with the SSL_session_reused(3) call.

If there is already a session set inside ssl (because it was set with `SSL_set_session()` before or because the same ssl was already used for a connection), `SSL_SESSION_free()` will be called for that session. If that old session is still open, it is considered bad and will be removed from the session cache (if used). A session is considered open, if SSL_shutdown(3) was not called for the connection (or at least SSL_set_shutdown(3) was used to set the SSL_SENT_SHUTDOWN state).

# NOTES

SSL_SESSION objects keep internal link information about the session cache list, when being inserted into one SSL_CTX object's session cache. One SSL_SESSION object, regardless of its reference count, must therefore only be used with one SSL_CTX object (and the SSL objects created from this SSL_CTX object).

# RETURN VALUES

The following return values can occur:

1. The operation failed; check the error stack to find out the reason.

2. The operation succeeded.

# SEE ALSO

ssl(7), SSL_SESSION_free(3), SSL_get_session(3), SSL_session_reused(3), SSL_CTX_set_session_cache_mode(3)

# COPYRIGHT

Copyright 2000-2016 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the OpenSSL license (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.